"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _dualListSelect = _interopRequireDefault(require("@data-driven-forms/common/dual-list-select"));

var _menu = require("@blueprintjs/core/lib/cjs/components/menu/menu.js");

var _menuItem = require("@blueprintjs/core/lib/cjs/components/menu/menuItem.js");

var _buttonGroup = require("@blueprintjs/core/lib/cjs/components/button/buttonGroup.js");

var _buttons = require("@blueprintjs/core/lib/cjs/components/button/buttons.js");

var _controlGroup = require("@blueprintjs/core/lib/cjs/components/forms/controlGroup.js");

var _inputGroup = require("@blueprintjs/core/lib/cjs/components/forms/inputGroup.js");

var _clsx = _interopRequireDefault(require("clsx"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _formGroup = require("../form-group/form-group");

var useStyles = (0, _reactJssCjs.createUseStyles)({
  menu: {
    height: '80%',
    overflow: 'auto'
  },
  buttonGroup: {
    justifyContent: 'center'
  },
  wrapper: {
    display: 'flex',
    justifyContent: 'space-evenly',
    minHeight: 250
  },
  '@media (max-width: 768px)': {
    wrapper: {
      flexDirection: 'column'
    }
  }
});

var List = function List(_ref) {
  var _ref$value = _ref.value,
      value = _ref$value === void 0 ? [] : _ref$value,
      optionClick = _ref.optionClick,
      noOptionsTitle = _ref.noOptionsTitle,
      filterValue = _ref.filterValue,
      filterValueText = _ref.filterValueText,
      selectedValues = _ref.selectedValues,
      _ref$MenuProps = _ref.MenuProps,
      MenuProps = _ref$MenuProps === void 0 ? {} : _ref$MenuProps,
      _ref$MenuItemProps = _ref.MenuItemProps,
      MenuItemProps = _ref$MenuItemProps === void 0 ? {} : _ref$MenuItemProps;

  var _useStyles = useStyles(),
      menu = _useStyles.menu;

  return /*#__PURE__*/_react["default"].createElement(_menu.Menu, (0, _extends2["default"])({}, MenuProps, {
    className: (0, _clsx["default"])('bp4-elevation-1', menu, MenuProps.className)
  }), value.length < 1 && /*#__PURE__*/_react["default"].createElement(_menuItem.MenuItem, (0, _extends2["default"])({
    text: filterValue ? filterValueText : noOptionsTitle,
    disabled: true
  }, MenuItemProps)), value.length > 0 && value.map(function (_ref2) {
    var value = _ref2.value,
        label = _ref2.label,
        ItemMenuItemProps = _ref2.MenuItemProps;
    return /*#__PURE__*/_react["default"].createElement(_menuItem.MenuItem, (0, _extends2["default"])({
      onClick: function onClick(e) {
        return optionClick(e, value);
      },
      key: value,
      active: selectedValues.includes(value),
      text: label
    }, MenuItemProps, ItemMenuItemProps));
  }));
};

List.propTypes = {
  value: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].string.isRequired,
    label: _propTypes["default"].string.isRequired
  })),
  optionClick: _propTypes["default"].func.isRequired,
  noOptionsTitle: _propTypes["default"].node,
  filterValue: _propTypes["default"].string,
  filterValueText: _propTypes["default"].node,
  selectedValues: _propTypes["default"].array,
  checkboxVariant: _propTypes["default"].bool,
  MenuProps: _propTypes["default"].object,
  MenuItemProps: _propTypes["default"].object
};

var Toolbar = function Toolbar(_ref3) {
  var sortTitle = _ref3.sortTitle,
      onFilter = _ref3.onFilter,
      onSort = _ref3.onSort,
      sortDirection = _ref3.sortDirection,
      value = _ref3.value,
      placeholder = _ref3.placeholder,
      _ref3$ControlGroupPro = _ref3.ControlGroupProps,
      ControlGroupProps = _ref3$ControlGroupPro === void 0 ? {} : _ref3$ControlGroupPro,
      _ref3$InputGroupProps = _ref3.InputGroupProps,
      InputGroupProps = _ref3$InputGroupProps === void 0 ? {} : _ref3$InputGroupProps,
      _ref3$ButtonProps = _ref3.ButtonProps,
      ButtonProps = _ref3$ButtonProps === void 0 ? {} : _ref3$ButtonProps;
  return /*#__PURE__*/_react["default"].createElement(_controlGroup.ControlGroup, ControlGroupProps, /*#__PURE__*/_react["default"].createElement(_inputGroup.InputGroup, (0, _extends2["default"])({
    placeholder: placeholder,
    onChange: function onChange(e) {
      return onFilter(e.target.value);
    },
    value: value
  }, InputGroupProps)), /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    icon: sortDirection ? 'sort-desc' : 'sort-asc',
    title: sortTitle,
    onClick: onSort
  }, ButtonProps)));
};

Toolbar.propTypes = {
  sortTitle: _propTypes["default"].node,
  onFilter: _propTypes["default"].func.isRequired,
  onSort: _propTypes["default"].func.isRequired,
  sortDirection: _propTypes["default"].bool,
  value: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  ControlGroupProps: _propTypes["default"].object,
  InputGroupProps: _propTypes["default"].object,
  ButtonProps: _propTypes["default"].object
};

var DualListInternal = function DualListInternal(_ref4) {
  var _ref4$allToRight = _ref4.allToRight,
      allToRight = _ref4$allToRight === void 0 ? true : _ref4$allToRight,
      _ref4$allToLeft = _ref4.allToLeft,
      allToLeft = _ref4$allToLeft === void 0 ? true : _ref4$allToLeft,
      _ref4$leftTitle = _ref4.leftTitle,
      leftTitle = _ref4$leftTitle === void 0 ? 'Options' : _ref4$leftTitle,
      _ref4$moveAllLeftTitl = _ref4.moveAllLeftTitle,
      moveAllLeftTitle = _ref4$moveAllLeftTitl === void 0 ? 'Move all to left' : _ref4$moveAllLeftTitl,
      _ref4$moveAllRightTit = _ref4.moveAllRightTitle,
      moveAllRightTitle = _ref4$moveAllRightTit === void 0 ? 'Move all to right' : _ref4$moveAllRightTit,
      _ref4$moveRightTitle = _ref4.moveRightTitle,
      moveRightTitle = _ref4$moveRightTitle === void 0 ? 'Move selected to right' : _ref4$moveRightTitle,
      _ref4$moveLeftTitle = _ref4.moveLeftTitle,
      moveLeftTitle = _ref4$moveLeftTitle === void 0 ? 'Move selected to left' : _ref4$moveLeftTitle,
      _ref4$rightTitle = _ref4.rightTitle,
      rightTitle = _ref4$rightTitle === void 0 ? 'Selected' : _ref4$rightTitle,
      _ref4$noValueTitle = _ref4.noValueTitle,
      noValueTitle = _ref4$noValueTitle === void 0 ? 'No selected' : _ref4$noValueTitle,
      _ref4$noOptionsTitle = _ref4.noOptionsTitle,
      noOptionsTitle = _ref4$noOptionsTitle === void 0 ? 'No available options' : _ref4$noOptionsTitle,
      _ref4$filterOptionsTi = _ref4.filterOptionsTitle,
      filterOptionsTitle = _ref4$filterOptionsTi === void 0 ? 'Filter options' : _ref4$filterOptionsTi,
      _ref4$filterValueTitl = _ref4.filterValueTitle,
      filterValueTitle = _ref4$filterValueTitl === void 0 ? 'Filter selected value' : _ref4$filterValueTitl,
      _ref4$filterValueText = _ref4.filterValueText,
      filterValueText = _ref4$filterValueText === void 0 ? 'Remove your filter to see all selected' : _ref4$filterValueText,
      _ref4$filterOptionsTe = _ref4.filterOptionsText,
      filterOptionsText = _ref4$filterOptionsTe === void 0 ? 'Remove your filter to see all options' : _ref4$filterOptionsTe,
      state = _ref4.state,
      sortOptions = _ref4.sortOptions,
      filterOptions = _ref4.filterOptions,
      handleOptionsClick = _ref4.handleOptionsClick,
      leftValues = _ref4.leftValues,
      handleMoveRight = _ref4.handleMoveRight,
      handleMoveLeft = _ref4.handleMoveLeft,
      handleClearLeftValues = _ref4.handleClearLeftValues,
      handleClearRightValues = _ref4.handleClearRightValues,
      sortValues = _ref4.sortValues,
      filterValues = _ref4.filterValues,
      rightValues = _ref4.rightValues,
      handleValuesClick = _ref4.handleValuesClick,
      _ref4$WrapperProps = _ref4.WrapperProps,
      WrapperProps = _ref4$WrapperProps === void 0 ? {} : _ref4$WrapperProps,
      _ref4$LeftWrapperProp = _ref4.LeftWrapperProps,
      LeftWrapperProps = _ref4$LeftWrapperProp === void 0 ? {} : _ref4$LeftWrapperProp,
      _ref4$RightWrapperPro = _ref4.RightWrapperProps,
      RightWrapperProps = _ref4$RightWrapperPro === void 0 ? {} : _ref4$RightWrapperPro,
      _ref4$ButtonGroupProp = _ref4.ButtonGroupProps,
      ButtonGroupProps = _ref4$ButtonGroupProp === void 0 ? {} : _ref4$ButtonGroupProp,
      _ref4$ToRightButtonPr = _ref4.ToRightButtonProps,
      ToRightButtonProps = _ref4$ToRightButtonPr === void 0 ? {} : _ref4$ToRightButtonPr,
      _ref4$AllToRightButto = _ref4.AllToRightButtonProps,
      AllToRightButtonProps = _ref4$AllToRightButto === void 0 ? {} : _ref4$AllToRightButto,
      _ref4$AllToLeftButton = _ref4.AllToLeftButtonProps,
      AllToLeftButtonProps = _ref4$AllToLeftButton === void 0 ? {} : _ref4$AllToLeftButton,
      _ref4$ToLeftButtonPro = _ref4.ToLeftButtonProps,
      ToLeftButtonProps = _ref4$ToLeftButtonPro === void 0 ? {} : _ref4$ToLeftButtonPro,
      _ref4$LeftControlGrou = _ref4.LeftControlGroupProps,
      LeftControlGroupProps = _ref4$LeftControlGrou === void 0 ? {} : _ref4$LeftControlGrou,
      _ref4$LeftInputGroupP = _ref4.LeftInputGroupProps,
      LeftInputGroupProps = _ref4$LeftInputGroupP === void 0 ? {} : _ref4$LeftInputGroupP,
      _ref4$LeftButtonProps = _ref4.LeftButtonProps,
      LeftButtonProps = _ref4$LeftButtonProps === void 0 ? {} : _ref4$LeftButtonProps,
      _ref4$RightControlGro = _ref4.RightControlGroupProps,
      RightControlGroupProps = _ref4$RightControlGro === void 0 ? {} : _ref4$RightControlGro,
      _ref4$RightInputGroup = _ref4.RightInputGroupProps,
      RightInputGroupProps = _ref4$RightInputGroup === void 0 ? {} : _ref4$RightInputGroup,
      _ref4$RightButtonProp = _ref4.RightButtonProps,
      RightButtonProps = _ref4$RightButtonProp === void 0 ? {} : _ref4$RightButtonProp,
      _ref4$LeftMenuProps = _ref4.LeftMenuProps,
      LeftMenuProps = _ref4$LeftMenuProps === void 0 ? {} : _ref4$LeftMenuProps,
      _ref4$LeftMenuItemPro = _ref4.LeftMenuItemProps,
      LeftMenuItemProps = _ref4$LeftMenuItemPro === void 0 ? {} : _ref4$LeftMenuItemPro,
      _ref4$RightMenuProps = _ref4.RightMenuProps,
      RightMenuProps = _ref4$RightMenuProps === void 0 ? {} : _ref4$RightMenuProps,
      _ref4$RightMenuItemPr = _ref4.RightMenuItemProps,
      RightMenuItemProps = _ref4$RightMenuItemPr === void 0 ? {} : _ref4$RightMenuItemPr,
      _ref4$leftSortTitle = _ref4.leftSortTitle,
      leftSortTitle = _ref4$leftSortTitle === void 0 ? 'Sort options' : _ref4$leftSortTitle,
      _ref4$rightSortTitle = _ref4.rightSortTitle,
      rightSortTitle = _ref4$rightSortTitle === void 0 ? 'Sort value' : _ref4$rightSortTitle;

  var _useStyles2 = useStyles(),
      buttonGroup = _useStyles2.buttonGroup,
      wrapper = _useStyles2.wrapper;

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, WrapperProps, {
    className: (0, _clsx["default"])(wrapper, WrapperProps.className)
  }), /*#__PURE__*/_react["default"].createElement("div", LeftWrapperProps, leftTitle, /*#__PURE__*/_react["default"].createElement(Toolbar, {
    sortDirection: state.sortLeftDesc,
    onSort: sortOptions,
    onFilter: filterOptions,
    value: state.filterOptions,
    placeholder: filterOptionsTitle,
    ControlGroupProps: LeftControlGroupProps,
    InputGroupProps: LeftInputGroupProps,
    ButtonProps: LeftButtonProps,
    sortTitle: leftSortTitle
  }), /*#__PURE__*/_react["default"].createElement(List, {
    optionClick: handleOptionsClick,
    value: leftValues,
    noOptionsTitle: noOptionsTitle,
    filterValue: state.filterOptions,
    filterValueText: filterOptionsText,
    selectedValues: state.selectedLeftValues,
    MenuProps: LeftMenuProps,
    MenuItemProps: LeftMenuItemProps
  })), /*#__PURE__*/_react["default"].createElement(_buttonGroup.ButtonGroup, (0, _extends2["default"])({
    vertical: true,
    alignText: "center"
  }, ButtonGroupProps, {
    className: (0, _clsx["default"])(buttonGroup, ButtonGroupProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    disabled: state.selectedLeftValues.length === 0,
    onClick: handleMoveRight,
    title: moveRightTitle,
    icon: "chevron-right"
  }, ToRightButtonProps)), allToRight && /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    disabled: leftValues.length === 0,
    onClick: handleClearLeftValues,
    title: moveAllRightTitle,
    icon: "double-chevron-right"
  }, AllToRightButtonProps)), allToLeft && /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    disabled: rightValues.length === 0,
    onClick: handleClearRightValues,
    title: moveAllLeftTitle,
    icon: "double-chevron-left"
  }, AllToLeftButtonProps)), /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    disabled: state.selectedRightValues.length === 0,
    onClick: handleMoveLeft,
    title: moveLeftTitle,
    icon: "chevron-left"
  }, ToLeftButtonProps))), /*#__PURE__*/_react["default"].createElement("div", RightWrapperProps, rightTitle, /*#__PURE__*/_react["default"].createElement(Toolbar, {
    sortDirection: state.sortRightDesc,
    onSort: sortValues,
    onFilter: filterValues,
    value: state.filterValue,
    placeholder: filterValueTitle,
    ControlGroupProps: RightControlGroupProps,
    InputGroupProps: RightInputGroupProps,
    ButtonProps: RightButtonProps,
    sortTitle: rightSortTitle
  }), /*#__PURE__*/_react["default"].createElement(List, {
    optionClick: handleValuesClick,
    value: rightValues,
    noOptionsTitle: noValueTitle,
    filterValue: state.filterValue,
    filterValueText: filterValueText,
    selectedValues: state.selectedRightValues,
    MenuProps: RightMenuProps,
    MenuItemProps: RightMenuItemProps
  })));
};

DualListInternal.propTypes = {
  leftTitle: _propTypes["default"].node,
  rightTitle: _propTypes["default"].node,
  moveLeftTitle: _propTypes["default"].node,
  moveRightTitle: _propTypes["default"].node,
  allToLeft: _propTypes["default"].bool,
  allToRight: _propTypes["default"].bool,
  validateOnMount: _propTypes["default"].bool,
  moveAllLeftTitle: _propTypes["default"].node,
  moveAllRightTitle: _propTypes["default"].node,
  noValueTitle: _propTypes["default"].node,
  noOptionsTitle: _propTypes["default"].node,
  filterOptionsTitle: _propTypes["default"].node,
  filterValueTitle: _propTypes["default"].node,
  filterValueText: _propTypes["default"].node,
  filterOptionsText: _propTypes["default"].node,
  state: _propTypes["default"].object,
  sortOptions: _propTypes["default"].func,
  filterOptions: _propTypes["default"].func,
  handleOptionsClick: _propTypes["default"].func,
  leftValues: _propTypes["default"].array,
  handleMoveRight: _propTypes["default"].func,
  handleMoveLeft: _propTypes["default"].func,
  handleClearLeftValues: _propTypes["default"].func,
  handleClearRightValues: _propTypes["default"].func,
  sortValues: _propTypes["default"].func,
  filterValues: _propTypes["default"].func,
  rightValues: _propTypes["default"].array,
  handleValuesClick: _propTypes["default"].func,
  WrapperProps: _propTypes["default"].object,
  LeftWrapperProps: _propTypes["default"].object,
  RightWrapperProps: _propTypes["default"].object,
  ButtonGroupProps: _propTypes["default"].object,
  ToRightButtonProps: _propTypes["default"].object,
  AllToRightButtonProps: _propTypes["default"].object,
  AllToLeftButtonProps: _propTypes["default"].object,
  ToLeftButtonProps: _propTypes["default"].object,
  LeftControlGroupProps: _propTypes["default"].object,
  LeftInputGroupProps: _propTypes["default"].object,
  LeftButtonProps: _propTypes["default"].object,
  RightControlGroupProps: _propTypes["default"].object,
  RightInputGroupProps: _propTypes["default"].object,
  RightButtonProps: _propTypes["default"].object,
  LeftMenuProps: _propTypes["default"].object,
  LeftMenuItemProps: _propTypes["default"].object,
  RightMenuProps: _propTypes["default"].object,
  RightMenuItemProps: _propTypes["default"].object,
  leftSortTitle: _propTypes["default"].string,
  rightSortTitle: _propTypes["default"].string
};

var DualListWrapper = function DualListWrapper(props) {
  return /*#__PURE__*/_react["default"].createElement(_formGroup.FormGroupInternal, (0, _extends2["default"])({}, props, {
    Component: DualListInternal
  }));
};

var DualListSelect = function DualListSelect(props) {
  return /*#__PURE__*/_react["default"].createElement(_dualListSelect["default"], (0, _extends2["default"])({}, props, {
    DualListSelect: DualListWrapper
  }));
};

var _default = DualListSelect;
exports["default"] = _default;